/*
 *	area.h
 */

/*	Copyright (C) 1999, 2000, 2001 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef AREA_H
#define AREA_H

#include <stdio.h>
#include "global.h"
#include "common.h"

struct area_s {
	area_s	*left, *right;
	dword	start, end;
};

class area: public object {
public:
	area_s		*a;
			void     	init();
			int 		load(ht_stream_filter *f);
	virtual	void 	done();

			void		add(dword Start, dword End);
			bool		contains(dword V);
			dword	findnext(dword From);
			dword	findprev(dword From);
			void		free_recursive(area_s *p);
	virtual	void		store(ht_stream_filter *f);
#ifdef DEBUG
			void		dump();
#endif
};

#endif
