/*
 *	htanaly.h
 */

/*	Copyright (C) 1999, 2000, 2001 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef HTANALY_H
#define HTANALY_H

#include "analy.h"
#include "global.h"
#include "htdialog.h"
#include "htformat.h"
#include "htobj.h"

/*
 *
 */

class symbolbox: public ht_listbox {
public:
	analyser	*analy;
	char		*str;
	int		idle_count;

			void init(bounds *b, analyser *Analy);
	virtual   void done();
	virtual   int  calc_count();
	virtual   int  cursor_adjust();
	virtual   void *getfirst();
	virtual   void *getlast();
	virtual   void *getnext(void *entry);
	virtual   void *getnth(int n);
	virtual   void *getprev(void *entry);
	virtual   char *getstr(int col, void *entry);
	virtual	bool idle();
	virtual   int	num_cols();
	virtual	void *quickfind(char *s);
	virtual	char	*quickfind_completition(char *s);
};

/*
 *
 */

class bookmark: public ht_data {
	ID		id1, id2;
	int		shortcut;
			void init(ID Id1, ID Id2);
	virtual   void done();
			void assign_shortcut(int sc);
			int	get_shortcur();
};

#define ANALY_STATUS_DEFAULT "<%s> @%08lx  %s\n%s"
#define ANALY_STATUS_DEFAULT_ARG_ORDER "ocuf"
#define ANALY_STATUS_ARG_FILEOFFSET 'o'
#define ANALY_STATUS_ARG_CODEBYTES 'c'
#define ANALY_STATUS_ARG_RAWUNASM 'u'
#define ANALY_STATUS_ARG_FUNCTION 'f'

class ht_aviewer;

class analy_infoline: public ht_statictext {
public:
	ht_aviewer	*analy;
	char			*s;
	dword		fofs;
	ADDR			addr;
	char			*displayformat;
			void	init(bounds *b, ht_aviewer *A, char *Format);
	virtual	void done();
	virtual	char *gettext();
			void update(ADDR cursor_addr, ADDR ecursor_addr);
			bool valid();
};

/*
 *	CLASS ht_aviewer
 */

class ht_aviewer: public ht_uformat_view {
public:
	int idle_count;
	analyser *analy;
	int last_active;
	analy_infoline *infoline;
			void init(bounds *b, char *desc, int caps, ht_stream *stream, ht_format_group *format_group, analyser *Analy);
	virtual	void	done();
	virtual	bool address_to_offset(fmt_vaddress addr, STREAMOFS *ofs);
			void	attach_infoline(analy_infoline *V);
	virtual	char *func(UINT i, bool execute);
	virtual	void	handlemsg(htmsg *msg);
	virtual	bool	idle();
	virtual	bool offset_to_address(STREAMOFS ofs, fmt_vaddress *addr);
	virtual	int	ref_sel(ID id_low, ID id_high);
			void show_xrefs(ADDR Addr);
	virtual	bool string_to_address(char *string, fmt_vaddress *vaddr);
};

/*
 *	CLASS hts_analy
 */

class hts_analy: public hts_sub {
public:
	analyser		*analy;
	ADDR			lowestaddress, highestaddress;
			void init(ht_stream *file, analyser *A, ADDR Lowestaddress, ADDR Highestaddress);
	virtual	void	done();
	virtual	bool convert_addr_to_id(fmt_vaddress addr, ID *id1, ID *id2);
	virtual	bool convert_id_to_addr(ID id1, ID id2, fmt_vaddress *addr);
	virtual	void	first_line_id(ID *id1, ID *id2);
	virtual	bool	getline(char *line, ID id1, ID id2);
	virtual	void	last_line_id(ID *id1, ID *id2);
	virtual	int	next_line_id(ID *id1, ID *id2, int n);
	virtual	int	prev_line_id(ID *id1, ID *id2, int n);
//	virtual	int	search(ht_search *s, STREAMOFS start, STREAMOFS end, STREAMOFS *offset, dword *size);
};

#endif
