/* 
 *	HT Editor
 *	htnewexe.cc
 *
 *	Copyright (C) 1999, 2000, 2001 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htnewexe.h"

#include "mzstruct.h"

STREAMOFS get_newexe_header_ofs(ht_stream *file)
{
/* look for mz magic */
	word mzmagic;
	file->seek(0);
	file->read(&mzmagic, 2);
	if (mzmagic!=IMAGE_MZ_MAGIC) return 0;
/* test if reloc_ofs>=0x40 */
	word reloc_ofs;
	file->seek(24);
	file->read(&reloc_ofs, 2);
	if (reloc_ofs<0x40) return 0;
/* ok seems to be a newexe */
	STREAMOFS newexe_ofs;
	file->seek(60);
	file->read(&newexe_ofs, 4);
	return newexe_ofs;
}

