/*
 *	HT Editor
 *	htpal.cc
 *
 *	Copyright (C) 1999, 2000, 2001 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htcurses.h"
#include "htpal.h"
#include "htreg.h"
#include "httag.h"
#include "htstring.h"

#include <stdlib.h>

/* WINDIALOG - BLACK */
defpal defpal_windialog_black[palcolors_windialog]={
{palidx_windialog_body,				"body", VCP(VC_WHITE, VC_BLACK)},
{palidx_windialog_shortcut, 			"shortcut", VCP(VC_LIGHT(VC_WHITE), VC_TRANSPARENT)},
{palidx_windialog_frame_focused,		"focused frame", VCP(VC_WHITE, VC_TRANSPARENT)},
{palidx_windialog_frame_unfocused,		"unfocused frame", VCP(VC_WHITE, VC_TRANSPARENT)},
{palidx_windialog_frame_moved, 		"moved frame", VCP(VC_LIGHT(VC_GREEN), VC_TRANSPARENT)},
{palidx_windialog_frame_killer,		"frame icons", VCP(VC_GREEN, VC_TRANSPARENT)},
{palidx_windialog_scrollbar,			"scrollbar", VCP(VC_WHITE, VC_BLACK)},

{palidx_windialog_input_focused,		"input focused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_unfocused,		"input unfocused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_selected,		"input selected", VCP(VC_BLACK, VC_WHITE)},
{palidx_windialog_input_clip,			"input clipping chars (<,>)", VCP(VC_WHITE, VC_BLUE)},

{palidx_windialog_button_focused,		"button focused", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_button_unfocused,	"button unfocused", VCP(VC_BLACK, VC_GREEN)},
{palidx_windialog_button_shadow,		"button shadow", VCP(VC_LIGHT(VC_BLACK), VC_BLACK)},
{palidx_windialog_button_shortcut,		"button shortcut", VCP(VC_BLACK, VC_WHITE)},

{palidx_windialog_list_focused_selected, "list focused & selected", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_list_focused_unselected, "list focused & unselected", VCP(VC_WHITE, VC_BLACK)},
{palidx_windialog_list_unfocused_selected, "list unfocused & selected", VCP(VC_LIGHT(VC_WHITE), VC_BLACK)},
{palidx_windialog_list_unfocused_unselected, "list unfocused & unselected", VCP(VC_WHITE, VC_BLACK)},

{palidx_windialog_cluster_focused,		"cluster focused", VCP(VC_LIGHT(VC_WHITE), VC_CYAN)},
{palidx_windialog_cluster_unfocused,	"cluster unfocused", VCP(VC_BLACK, VC_CYAN)},
{palidx_windialog_cluster_shortcut,	"cluster shortcut", VCP(VC_BLACK, VC_CYAN)}
};

/* WINDIALOG - SPECIAL */
defpal defpal_windialog_special[palcolors_windialog]={
{palidx_windialog_body,				"body", VCP(VC_WHITE, VC_BLACK)},
{palidx_windialog_shortcut, 			"shortcut", VCP(VC_BLACK, VC_WHITE)},
{palidx_windialog_frame_focused,		"focused frame", VCP(VC_WHITE, VC_BLACK)},
{palidx_windialog_frame_unfocused,		"unfocused frame", VCP(VC_WHITE, VC_BLACK)},
{palidx_windialog_frame_moved, 		"moved frame", VCP(VC_LIGHT(VC_GREEN), VC_BLACK)},
{palidx_windialog_frame_killer,		"frame icons", VCP(VC_GREEN, VC_BLACK)},
{palidx_windialog_scrollbar,			"scrollbar", VCP(VC_WHITE, VC_BLACK)},

{palidx_windialog_input_focused,		"input focused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_unfocused,		"input unfocused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_selected,		"input selected", VCP(VC_BLACK, VC_WHITE)},
{palidx_windialog_input_clip,			"input clipping chars (<,>)", VCP(VC_WHITE, VC_BLUE)},

{palidx_windialog_button_focused,		"button focused", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_button_unfocused,	"button unfocused", VCP(VC_BLACK, VC_GREEN)},
{palidx_windialog_button_shadow,		"button shadow", VCP(VC_TRANSPARENT, VC_BLACK)},
{palidx_windialog_button_shortcut,		"button shortcut", VCP(VC_BLACK, VC_WHITE)},

{palidx_windialog_list_focused_selected, "list focused & selected", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_list_focused_unselected, "list focused & unselected", VCP(VC_WHITE, VC_BLACK)},
{palidx_windialog_list_unfocused_selected, "list unfocused & selected", VCP(VC_LIGHT(VC_WHITE), VC_BLACK)},
{palidx_windialog_list_unfocused_unselected, "list unfocused & unselected", VCP(VC_WHITE, VC_BLACK)},

{palidx_windialog_cluster_focused,		"cluster focused", VCP(VC_LIGHT(VC_WHITE), VC_CYAN)},
{palidx_windialog_cluster_unfocused,	"cluster unfocused", VCP(VC_BLACK, VC_CYAN)},
{palidx_windialog_cluster_shortcut,	"cluster shortcut", VCP(VC_BLACK, VC_CYAN)}
};

/* WINDIALOG - CYAN */
defpal defpal_windialog_cyan[palcolors_windialog]={
{palidx_windialog_body,				"body", VCP(VC_BLACK, VC_CYAN)},
{palidx_windialog_shortcut, 			"shortcut", VCP(VC_LIGHT(VC_YELLOW), VC_TRANSPARENT)},
{palidx_windialog_frame_focused,		"focused frame", VCP(VC_LIGHT(VC_WHITE), VC_TRANSPARENT)},
{palidx_windialog_frame_unfocused,		"unfocused frame", VCP(VC_WHITE, VC_TRANSPARENT)},
{palidx_windialog_frame_moved, 		"moved frame", VCP(VC_LIGHT(VC_GREEN), VC_TRANSPARENT)},
{palidx_windialog_frame_killer,		"frame icons", VCP(VC_LIGHT(VC_GREEN), VC_TRANSPARENT)},
{palidx_windialog_scrollbar,			"scrollbar", VCP(VC_CYAN, VC_BLUE)},

{palidx_windialog_input_focused,		"input focused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_unfocused,		"input unfocused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_selected,		"input selected", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_input_clip,			"input clipping chars (<,>)", VCP(VC_WHITE, VC_BLUE)},

{palidx_windialog_button_focused,		"button focused", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_button_unfocused,	"button unfocused", VCP(VC_BLACK, VC_GREEN)},
{palidx_windialog_button_shadow,		"button shadow", VCP(VC_LIGHT(VC_BLACK), VC_BLACK)},
{palidx_windialog_button_shortcut,		"button shortcut", VCP(VC_BLACK, VC_WHITE)},

{palidx_windialog_list_focused_selected, "list focused & selected", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_list_focused_unselected, "list focused & unselected", VCP(VC_BLACK, VC_CYAN)},
{palidx_windialog_list_unfocused_selected, "list unfocused & selected", VCP(VC_LIGHT(VC_WHITE), VC_CYAN)},
{palidx_windialog_list_unfocused_unselected, "list unfocused & unselected", VCP(VC_BLACK, VC_CYAN)},

{palidx_windialog_cluster_focused,		"cluster focused", VCP(VC_LIGHT(VC_WHITE), VC_CYAN)},
{palidx_windialog_cluster_unfocused,	"cluster unfocused", VCP(VC_BLACK, VC_CYAN)},
{palidx_windialog_cluster_shortcut,	"cluster shortcut", VCP(VC_LIGHT(VC_YELLOW), VC_CYAN)}
};

/* WINDIALOG - BLUE */
defpal defpal_windialog_blue[palcolors_windialog]={
{palidx_windialog_body,				"body", VCP(VC_BLACK, VC_BLUE)},
{palidx_windialog_shortcut, 			"shortcut", VCP(VC_LIGHT(VC_YELLOW), VC_TRANSPARENT)},
{palidx_windialog_frame_focused,		"focused frame", VCP(VC_LIGHT(VC_WHITE), VC_TRANSPARENT)},
{palidx_windialog_frame_unfocused,		"unfocused frame", VCP(VC_WHITE, VC_TRANSPARENT)},
{palidx_windialog_frame_moved, 		"moved frame", VCP(VC_LIGHT(VC_GREEN), VC_TRANSPARENT)},
{palidx_windialog_frame_killer,		"frame icons", VCP(VC_LIGHT(VC_GREEN), VC_TRANSPARENT)},
{palidx_windialog_scrollbar,			"scrollbar", VCP(VC_CYAN, VC_BLUE)},

{palidx_windialog_input_focused,		"input focused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_unfocused,		"input unfocused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_selected,		"input selected", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_input_clip,			"input clipping chars (<,>)", VCP(VC_WHITE, VC_BLUE)},

{palidx_windialog_button_focused,		"button focused", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_button_unfocused,	"button unfocused", VCP(VC_BLACK, VC_GREEN)},
{palidx_windialog_button_shadow,		"button shadow", VCP(VC_LIGHT(VC_BLACK), VC_BLACK)},
{palidx_windialog_button_shortcut,		"button shortcut", VCP(VC_BLACK, VC_WHITE)},

{palidx_windialog_list_focused_selected, "list focused & selected", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_list_focused_unselected, "list focused & unselected", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_list_unfocused_selected, "list unfocused & selected", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_list_unfocused_unselected, "list unfocused & unselected", VCP(VC_BLACK, VC_BLUE)},

{palidx_windialog_cluster_focused,		"cluster focused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_cluster_unfocused,	"cluster unfocused", VCP(VC_BLACK, VC_BLUE)},
{palidx_windialog_cluster_shortcut,	"cluster shortcut", VCP(VC_LIGHT(VC_YELLOW), VC_BLUE)}
};

/* WINDIALOG - GRAY */
defpal defpal_windialog_gray[palcolors_windialog]={
{palidx_windialog_body,				"body", VCP(VC_BLACK, VC_WHITE)},
{palidx_windialog_shortcut, 			"shortcut", VCP(VC_LIGHT(VC_YELLOW), VC_TRANSPARENT)},
{palidx_windialog_frame_focused,		"focused frame", VCP(VC_LIGHT(VC_WHITE), VC_TRANSPARENT)},
{palidx_windialog_frame_unfocused,		"unfocused frame", VCP(VC_LIGHT(VC_WHITE), VC_TRANSPARENT)},
{palidx_windialog_frame_moved, 		"moved frame", VCP(VC_LIGHT(VC_YELLOW), VC_TRANSPARENT)},
{palidx_windialog_frame_killer,		"frame icons", VCP(VC_LIGHT(VC_GREEN), VC_TRANSPARENT)},
{palidx_windialog_scrollbar,			"scrollbar", VCP(VC_CYAN, VC_BLUE)},

{palidx_windialog_input_focused,		"input focused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_unfocused,		"input unfocused", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_windialog_input_selected,		"input selected", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_input_clip,			"input clipping chars (<,>)", VCP(VC_WHITE, VC_BLUE)},

{palidx_windialog_button_focused,		"button focused", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_button_unfocused,	"button unfocused", VCP(VC_BLACK, VC_GREEN)},
{palidx_windialog_button_shadow,		"button shadow", VCP(VC_BLACK, VC_TRANSPARENT)},
{palidx_windialog_button_shortcut,		"button shortcut", VCP(VC_LIGHT(VC_YELLOW), VC_GREEN)},

{palidx_windialog_list_focused_selected, "list focused & selected", VCP(VC_LIGHT(VC_WHITE), VC_GREEN)},
{palidx_windialog_list_focused_unselected, "list focused & unselected", VCP(VC_BLACK, VC_CYAN)},
{palidx_windialog_list_unfocused_selected, "list unfocused & selected", VCP(VC_LIGHT(VC_WHITE), VC_CYAN)},
{palidx_windialog_list_unfocused_unselected, "list unfocused & unselected", VCP(VC_BLACK, VC_CYAN)},

{palidx_windialog_cluster_focused,		"cluster focused", VCP(VC_LIGHT(VC_WHITE), VC_CYAN)},
{palidx_windialog_cluster_unfocused,	"cluster unfocused", VCP(VC_BLACK, VC_CYAN)},
{palidx_windialog_cluster_shortcut,	"cluster shortcut", VCP(VC_LIGHT(VC_YELLOW), VC_CYAN)}
};

/* DESKTOP */
defpal defpal_desktop[palcolors_desktop]={
{palidx_windialog_body,				"body", VCP(VC_BLUE, VC_BLACK)}
};

/* KEYLINE */
defpal defpal_keyline[palcolors_keyline]={
{palidx_keyline_digit,				"digit", VCP(VC_WHITE, VC_BLACK)},
{palidx_keyline_active,				"active", VCP(VC_BLACK, VC_CYAN)},
{palidx_keyline_inactive,			"inactive", VCP(VC_WHITE, VC_CYAN)}
};

/* TAGS */
defpal defpal_tags_black[palcolors_tags]={
{palidx_tag_normal,					"normal", VCP(VC_WHITE, VC_TRANSPARENT)},
{palidx_tag_edit_cursor_sel,			"editable: select-cursor", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_tag_edit_cursor_edit,			"editable: edit-cursor", VCP(VC_LIGHT(VC_WHITE), VC_RED)},
{palidx_tag_edit_selected,			"editable: selected", VCP(VC_TRANSPARENT, VC_WHITE)},
{palidx_tag_edit_modified,			"editable: modified", VCP(VC_RED, VC_TRANSPARENT)},
{palidx_tag_edit_normal,				"editable: normal", VCP(VC_LIGHT(VC_BLACK), VC_TRANSPARENT)},
{palidx_tag_sel_cursor,				"selectable: cursor", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_tag_sel_normal,				"selectable: normal", VCP(VC_CYAN, VC_TRANSPARENT)}
};

defpal defpal_tags_blue[palcolors_tags]={
{palidx_tag_normal,					"normal", VCP(VC_LIGHT(VC_WHITE), VC_TRANSPARENT)},
{palidx_tag_edit_cursor_sel,			"editable: select-cursor", VCP(VC_LIGHT(VC_WHITE), VC_WHITE)},
{palidx_tag_edit_cursor_edit,			"editable: edit-cursor", VCP(VC_LIGHT(VC_WHITE), VC_RED)},
{palidx_tag_edit_selected,			"editable: selected", VCP(VC_TRANSPARENT, VC_WHITE)},
{palidx_tag_edit_modified,			"editable: modified", VCP(VC_RED, VC_TRANSPARENT)},
{palidx_tag_edit_normal,				"editable: normal", VCP(VC_WHITE, VC_TRANSPARENT)},
{palidx_tag_sel_cursor,				"selectable: cursor", VCP(VC_LIGHT(VC_WHITE), VC_BLUE)},
{palidx_tag_sel_normal,				"selectable: normal", VCP(VC_CYAN, VC_TRANSPARENT)}
};

/*
 *   reg/pal management
 */

int create_pal(char *pal_class, char *pal_name, defpal *p, int entry_count, ht_registry_node_type rnt_pal)
{
	char key[1024], *k=key;	/* FIXME: possible buffer overflow */
	k+=sprintf(k, "%s/%s/%s", palettekey, pal_class, pal_name);
	if (!registry->create_subdir(key)) return 0;
	k+=sprintf(k, "/");
	for (int i=0; i<entry_count; i++) {
		strcpy(k, p[i].name);
		if (!registry->create_node(key, rnt_pal)) return 0;
		if (!registry->set_node(key, rnt_pal, new palette_entry(p[i].idx, p[i].color))) return 0;
	}
	return 1;
}

vcp getcolorv(palette *pal, UINT index)
{
	if (index<pal->size) return pal->data[index];
	return VCP(VC_WHITE, VC_RED);
}

bool reloadpalettev(char *pal_class, char *pal_name, palette *p)
{
	if ((!pal_name) || (!pal_class)) return 0;
	char key[1024];	/* FIXME: possible buffer overflow ! */
	sprintf(key, "%s/%s/%s", palettekey, pal_class, pal_name);
	ht_registry_node_type t;
	palette_entry *d;
	char *n;
	ht_registry_node_type rnt_pal=registry->have_node_type(rnt_palette_name);
	UINT entry_count=0;
	UINT pal_size=0;
	if (registry->enum_first(key, &n, (ht_data**)&d, &t)) {
		do {
			if (t==rnt_pal) {
				if (d->idx+1>pal_size) pal_size=d->idx+1;
				entry_count++;
			}
		} while (registry->enum_next(&n, (ht_data**)&d, &t));
	}

	if ((pal_size==entry_count) && (pal_size)) {
		vcp *pal=(vcp*)malloc(sizeof (vcp) * pal_size);
		if (registry->enum_first(key, &n, (ht_data**)&d, &t)) {
			do {
				if (t==rnt_pal) {
					pal[d->idx]=d->color;
				}
			} while (registry->enum_next(&n, (ht_data**)&d, &t));
		}
		p->data=pal;
		p->size=pal_size;
		return 1;
	}
	return 0;
}


/*
 *	CLASS palette_entry
 */

palette_entry::palette_entry(UINT _idx=0, vcp _color=0)
{
	idx=_idx;
	color=_color;
}

/*
 *	INIT
 */

int init_pal()
{
	int b=1;
	ht_registry_node_type rnt_pal=registry->have_node_type(rnt_palette_name);

	b&=registry->create_subdir(palettekey);

/* WINDIALOG */
	b&=registry->create_subdir(palettekey"/"palclasskey_windialog);

	b&=create_pal(palclasskey_windialog, palkey_windialog_black, defpal_windialog_black, palcolors_windialog, rnt_pal);
	b&=create_pal(palclasskey_windialog, palkey_windialog_special, defpal_windialog_special, palcolors_windialog, rnt_pal);
	b&=create_pal(palclasskey_windialog, palkey_windialog_cyan, defpal_windialog_cyan, palcolors_windialog, rnt_pal);
	b&=create_pal(palclasskey_windialog, palkey_windialog_blue, defpal_windialog_blue, palcolors_windialog, rnt_pal);
	b&=create_pal(palclasskey_windialog, palkey_windialog_gray, defpal_windialog_gray, palcolors_windialog, rnt_pal);

	b&=registry->create_symlink(palettekey"/"palclasskey_windialog"/"palkey_windialog_window_default);
	b&=registry->set_symlink(palettekey"/"palclasskey_windialog"/"palkey_windialog_window_default, palkey_windialog_black);
//     b&=registry->set_symlink(palettekey"/"palclasskey_windialog"/"palkey_windialog_window_default, palkey_windialog_blue);

	b&=registry->create_symlink(palettekey"/"palclasskey_windialog"/"palkey_windialog_dialog_default);
	b&=registry->set_symlink(palettekey"/"palclasskey_windialog"/"palkey_windialog_dialog_default, palkey_windialog_gray);

/* DESKTOP */
	b&=registry->create_subdir(palettekey"/"palclasskey_desktop);

	b&=create_pal(palclasskey_desktop, palkey_desktop_default, defpal_desktop, palcolors_desktop, rnt_pal);

/* KEYLINE */
	b&=registry->create_subdir(palettekey"/"palclasskey_keyline);

	b&=create_pal(palclasskey_keyline, palkey_keyline_default, defpal_keyline, palcolors_keyline, rnt_pal);

/* TAGS */
	b&=registry->create_subdir(palettekey"/"palclasskey_tags);

	b&=create_pal(palclasskey_tags, palkey_tags_black, defpal_tags_black, palcolors_tags, rnt_pal);
	b&=create_pal(palclasskey_tags, palkey_tags_blue, defpal_tags_blue, palcolors_tags, rnt_pal);

	b&=registry->create_symlink(palettekey"/"palclasskey_tags"/"palkey_tags_default);
	b&=registry->set_symlink(palettekey"/"palclasskey_tags"/"palkey_tags_default, palkey_tags_black);

/*     fprintf(stderr, "success=%d\n", b);
	registry->debug_dump();
	exit(1); */
	return b;
}

/*
 *	DONE
 */

int done_pal()
{
	return 1;
}

